<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<!--
 #*************************************************************************
 #
  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  
  Copyright 2008 by Sun Microsystems, Inc.
 
  OpenOffice.org - a multi-platform office productivity suite
 
  $RCSfile: package.html,v $
 
  $Revision: 1.4 $
 
  This file is part of OpenOffice.org.
 
  OpenOffice.org is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License version 3
  only, as published by the Free Software Foundation.
 
  OpenOffice.org is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License version 3 for more details
  (a copy is included in the LICENSE file that accompanied this code).
 
  You should have received a copy of the GNU Lesser General Public License
  version 3 along with OpenOffice.org.  If not, see
  <http://www.openoffice.org/license.html>
  for a copy of the LGPLv3 License.
 
 #*************************************************************************
 -->
<html>
<head>
<title>org.openoffice.xmerge.util.registry package</title>
</head>

<body bgcolor="white">

<p>Provides an interface for plug-in registration.  Each plug-in must
have a corresponding Plugin Configuration XML File which is named
converter.xml.  If the plug-in is stored in a jarfile, this
converter.xml file is typically stored in the following location in
the jarfile:</p>

<blockquote>
 META-INF/converter.xml
</blockquote>

<p>The Plugin Configuration XML File must validate against the
converter.dtd file provided with this package.  Since a jarfile
can contain multiple plug-ins, this DTD supports specifying multiple
plug-ins per jarfile.  Please refer to the SDK document for more
information about how to implement a Plugin Configuration XML File
for a specific plugin.</p>

<p>All information in the Plugin Configuratino XML File is bundled
into one or more <code>ConverterInfo</code> object.  The
<code>ConverterInfoReader</code> object is used to build a
<code>Vector</code> of <code>ConverterInfo</code> objects from a
jarfile.</p>

<p>The <code>ConverterInfoMgr</code> manages the registry of
<code>ConverterInfo</code>.  It is a singleton class, so that only one
registry manager will ever exist.  It is the client program's
responsibility to register <code>ConverterInfo</code> objects that
correspond to the plug-ins that are to be used.</p>

<h2>TODO/IDEAS list</h2>

<p><ol>
<li>The <code>ConverterInfo</code> object could contain
    <code>org.w3c.dom.Document</code> fragments that are accessed in a
    generic fashion rather than get/set methods for each item in the DTD.
    This would provide a more flexible approach, especially for adding
    custom tags to a specific Plugin Configuration XML file (tags that
    are only used by its associated plug-in).
<li><code>ConverterInfo</code> should allow the merge/serialize/deserialize
    logic to be included in separate plug-ins, if desired.</li>
<li><code>ConverterInfoMgr</code> could use the Java Activation
    Framework (JAF) to manage registration.</li>
</ol></p>

</body>
</html>
